-- Create Movie Stream Constraints

CREATE UNIQUE INDEX CUSTOMER_CONTACT_PK ON CUSTOMER_CONTACT (CUST_ID) reverse &logging;

alter table CUSTOMER_CONTACT
    add (constraint CUSTOMER_CONTACT_PK primary key (CUST_ID));

CREATE UNIQUE INDEX CUSTOMER_DEVICE_PK ON CUSTOMER_DEVICE (DEVICE_ID) reverse &logging;

alter table CUSTOMER_DEVICE
    add (constraint CUSTOMER_DEVICE_PK primary key (DEVICE_ID));

CREATE UNIQUE INDEX CUSTOMER_FRIENDS_AND_FAMILY_PK ON CUSTOMER_FRIENDS_AND_FAMILY (FRIEND_FAMILY_ID) reverse &logging;

alter table CUSTOMER_FRIENDS_AND_FAMILY
    add (constraint CUSTOMER_FRIENDS_AND_FAMILY_PK primary key (FRIEND_FAMILY_ID));

CREATE UNIQUE INDEX CUSTOMER_PAYMENT_INFORMATION_PK ON CUSTOMER_PAYMENT_INFORMATION (PAYMENT_INFORMATION_ID) reverse &logging;

alter table CUSTOMER_PAYMENT_INFORMATION
    add (constraint CUSTOMER_PAYMENT_INFORMATION_PK primary key (PAYMENT_INFORMATION_ID));

CREATE UNIQUE INDEX CUSTOMER_REVIEW_PK ON CUSTOMER_REVIEW (REVIEW_ID) reverse &logging;

alter table CUSTOMER_REVIEW
    add (constraint CUSTOMER_REVIEW_PK primary key (REVIEW_ID) );

CREATE UNIQUE INDEX CUSTOMER_SALES_TRANSACTION_PK ON CUSTOMER_SALES_TRANSACTION (SALES_TRANSACTION_ID) reverse &logging;

alter table CUSTOMER_SALES_TRANSACTION
    add (constraint CUSTOMER_SALES_TRANSACTION_PK primary key (SALES_TRANSACTION_ID));

CREATE UNIQUE INDEX INTERACTION_PK ON INTERACTION (INTERACTION_ID) reverse &logging;

alter table INTERACTION
    add (constraint INTERACTION_PK primary key (INTERACTION_ID));

alter table MOVIE
    add (constraint MOVIE_PK primary key (MOVIE_ID) );

ALTER TABLE CUSTOMER_DEVICE
    ADD (CONSTRAINT CD_CUST_CONTACT_fk FOREIGN KEY (CUST_ID) REFERENCES CUSTOMER_CONTACT (CUST_ID) );

ALTER TABLE CUSTOMER_FRIENDS_AND_FAMILY
    ADD (CONSTRAINT CFF_SOURCE_CUST_CONTACT_fk FOREIGN KEY (CUSTOMER_SOURCE) REFERENCES CUSTOMER_CONTACT (CUST_ID) );

ALTER TABLE CUSTOMER_FRIENDS_AND_FAMILY
    ADD (CONSTRAINT CFF_TARGET_CUST_CONTACT_fk FOREIGN KEY (CUSTOMER_TARGET) REFERENCES CUSTOMER_CONTACT (CUST_ID) );

ALTER TABLE CUSTOMER_PAYMENT_INFORMATION
    ADD (CONSTRAINT CPI_CUST_CONTACT_fk FOREIGN KEY (CUST_ID) REFERENCES CUSTOMER_CONTACT (CUST_ID) );

ALTER TABLE CUSTOMER_REVIEW
    ADD (CONSTRAINT CR_CUST_CONTACT_fk FOREIGN KEY (CUST_ID) REFERENCES CUSTOMER_CONTACT (CUST_ID) );

ALTER TABLE CUSTOMER_REVIEW
    ADD (CONSTRAINT CR_MOVIE_fk FOREIGN KEY (MOVIE_ID) REFERENCES MOVIE (MOVIE_ID) );

ALTER TABLE CUSTOMER_SALES_TRANSACTION
    ADD (CONSTRAINT CST_MOVIE_fk FOREIGN KEY (MOVIE_ID) REFERENCES MOVIE (MOVIE_ID) );

ALTER TABLE CUSTOMER_SALES_TRANSACTION
    ADD (CONSTRAINT CST_CUST_CONTACT_fk FOREIGN KEY (CUST_ID) REFERENCES CUSTOMER_CONTACT (CUST_ID) );

ALTER TABLE CUSTOMER_SALES_TRANSACTION
    ADD (CONSTRAINT CST_PAYMENT_INFO_fk FOREIGN KEY (CUSTOMER_PAYMENT_INFORMATION_ID) REFERENCES CUSTOMER_PAYMENT_INFORMATION (PAYMENT_INFORMATION_ID) );

alter table MOVIES_CAST_MAP
    add constraint MOVIES_CAST_MAP_fk
        foreign key (CAST_ID) references CAST (CAST_ID) ;

alter table MOVIES_CAST_MAP
    add constraint MOVIES_CAST_fk2
        foreign key (MOVIE_ID) references MOVIE_DETAILS (MOVIE_ID) ;

alter table MOVIES_CREW_MAP
    add constraint MOVIES_CREW_MAP_fk
        foreign key (CREW_ID) references CREW (CREW_ID) ;

alter table MOVIES_CREW_MAP
    add constraint MOVIES_CAST_MAP_fk2
        foreign key (MOVIE_ID) references MOVIE_DETAILS (MOVIE_ID) ;

alter table MOVIES_GENRE_MAP
    add constraint MOVIES_GENRE_MAP_PK
        primary key (MG_ID);

alter table MOVIES_GENRE_MAP
    add constraint MOVIES_GENRE_MAP_uk unique (MOVIE_ID, GENRE_ID);

alter table MOVIES_GENRE_MAP
    add constraint MOVIES_GENRE_MAP_fk
        foreign key (GENRE_ID) references GENRES (GENRE_ID) ;

alter table MOVIES_GENRE_MAP
    add constraint MOVIES_GENRE_MAP_fk2
        foreign key (MOVIE_ID) references MOVIE_DETAILS (MOVIE_ID) ;

alter table MOVIES_STUDIO_MAP
    add constraint MOVIES_STUDIO_MAP_fk
        foreign key (STUDIO_ID) references STUDIOS (STUDIO_ID) ;

alter table MOVIES_STUDIO_MAP
    add constraint MOVIES_STUDIO_MAP_fk2
        foreign key (MOVIE_ID) references MOVIE_DETAILS (MOVIE_ID) ;

alter table MOVIES_AWARD_MAP
    add constraint MOVIES_AWARD_MAP_fk
        foreign key (AWARDS_ID) references AWARDS (AWARD_ID) ;

alter table MOVIES_AWARD_MAP
    add constraint MOVIES_AWARD_MAP_fk2
        foreign key (MOVIE_ID) references MOVIE_DETAILS (MOVIE_ID) ;

alter table MOVIES_NOMINATION_MAP
    add constraint MOVIES_NOMINATION_MAP_FK
        foreign key (NOMINATION_ID) references NOMINATIONS (NOMINATION_ID) ;

alter table MOVIES_NOMINATION_MAP
    add constraint MOVIES_NOMINATION_MAP_FK2
        foreign key (MOVIE_ID) references MOVIE_DETAILS (MOVIE_ID) ;


